#include "EsoCommon_Header.hpp"
// ++++++++++++++++++++++++++++++++++
// + Code generated by dcc 1.0      +
// ++++++++++++++++++++++++++++++++++

void jsp_t1_acs_sum(jsp* x, jsp* t1_x, int& len, jsp& sum_x, jsp& t1_sum_x)
#pragma ad indep x t1_x
#pragma ad dep sum_x t1_sum_x
{
   int i=0; 
   jsp v1_0=0; 
   jsp t1_v1_0=0; 
   jsp v1_1=0; 
   jsp t1_v1_1=0; 
   jsp v1_2=0; 
   jsp t1_v1_2=0; 
   for ( i=0; i<len; i=i+1) {
      t1_v1_0=t1_sum_x;
      v1_0=sum_x;
      t1_v1_1=t1_x[i];
      v1_1=x[i];
      t1_v1_2=t1_v1_0+t1_v1_1;
      v1_2=v1_0+v1_1;
      t1_sum_x=t1_v1_2;
      sum_x=v1_2;
   }
}
void jsp_t1_acs_pow(jsp& a, jsp& t1_a, jsp& x, jsp& t1_x, jsp& v_pow, jsp& t1_v_pow)
#pragma ad indep a t1_a x t1_x
#pragma ad dep v_pow t1_v_pow
{
   jsp v1_0=0; 
   jsp t1_v1_0=0; 
   jsp v1_1=0; 
   jsp t1_v1_1=0; 
   jsp ret_mosc1=0; 
   t1_v1_0=t1_a;
   v1_0=a;
   jsp_acs_pow(v1_0,x,v1_1);
   t1_v1_1=x-1;
   jsp_acs_pow(v1_0,t1_v1_1,ret_mosc1);
   t1_v1_1=x*ret_mosc1*t1_v1_0+v1_1*jsp_dcc_log(v1_0)*t1_x;
   t1_v_pow=t1_v1_1;
   v_pow=v1_1;
}
void jsp_t1_acs_div(jsp& top_arg, jsp& t1_top_arg, jsp& bottom_arg, jsp& t1_bottom_arg, jsp& v_div, jsp& t1_v_div)
#pragma ad indep top_arg t1_top_arg bottom_arg t1_bottom_arg
#pragma ad dep v_div t1_v_div
{
   jsp v1_0=0; 
   jsp t1_v1_0=0; 
   jsp v1_1=0; 
   jsp t1_v1_1=0; 
   jsp v1_2=0; 
   jsp t1_v1_2=0; 
   jsp one=0; 
   t1_v1_0=t1_top_arg;
   v1_0=top_arg;
   t1_v1_1=t1_bottom_arg;
   v1_1=bottom_arg;
   one=1.0;
   jsp_acs_div(one,v1_1,v1_2);
   t1_v1_2=v1_2*t1_v1_0-v1_0*v1_2*v1_2*t1_v1_1;
   v1_2=v1_0*v1_2;
   t1_v_div=t1_v1_2;
   v_div=v1_2;
}
void jsp_t1_acs_sqrt(jsp& arg, jsp& t1_arg, jsp& v_sqrt, jsp& t1_v_sqrt)
#pragma ad indep arg t1_arg
#pragma ad dep v_sqrt t1_v_sqrt
{
   jsp v1_0=0; 
   jsp t1_v1_0=0; 
   jsp v1_1=0; 
   jsp t1_v1_1=0; 
   jsp one=0; 
   jsp ret_div=0; 
   jsp div_bottom_arg=0; 
   one=1.0;
   if (arg>=0) {
      t1_v1_0=t1_arg;
      v1_0=arg;
      jsp_acs_sqrt(v1_0,v1_1);
      div_bottom_arg=2*v1_1;
      jsp_acs_div(one,div_bottom_arg,ret_div);
      t1_v1_1=ret_div*t1_v1_0;
      t1_v_sqrt=t1_v1_1;
      v_sqrt=v1_1;
   }
   else {
      t1_v1_0=t1_arg;
      v1_0=0-arg;
      jsp_acs_sqrt(v1_0,v1_1);
      div_bottom_arg=2*v1_1;
      jsp_acs_div(one,div_bottom_arg,ret_div);
      t1_v1_1=ret_div*t1_v1_0;
      t1_v_sqrt=t1_v1_1;
      v_sqrt=v1_1;
   }
}
void jsp_t1_acs_ln(jsp& arg, jsp& t1_arg, jsp& v_ln, jsp& t1_v_ln)
#pragma ad indep arg t1_arg
#pragma ad dep v_ln t1_v_ln
{
   jsp v1_0=0; 
   jsp t1_v1_0=0; 
   jsp v1_1=0; 
   jsp t1_v1_1=0; 
   t1_v1_0=t1_arg;
   v1_0=arg;
   jsp_acs_div(t1_v1_0,v1_0,t1_v1_1);
   v1_1=jsp_dcc_log(v1_0);
   t1_v_ln=t1_v1_1;
   v_ln=v1_1;
}
void jsp_t1_acs_exp(jsp& arg, jsp& t1_arg, jsp& v_exp, jsp& t1_v_exp)
#pragma ad indep arg t1_arg
#pragma ad dep v_exp t1_v_exp
{
   jsp v1_0=0; 
   jsp t1_v1_0=0; 
   jsp v1_1=0; 
   jsp t1_v1_1=0; 
   t1_v1_0=t1_arg;
   v1_0=arg;
   jsp_acs_exp(v1_0,v1_1);
   t1_v1_1=v1_1*t1_v1_0;
   t1_v_exp=t1_v1_1;
   v_exp=v1_1;
}
void jsp_t1_acs_tanh(jsp& x, jsp& t1_x, jsp& v_tanh, jsp& t1_v_tanh)
#pragma ad indep x t1_x
#pragma ad dep v_tanh t1_v_tanh
{
   jsp v1_0=0; 
   jsp t1_v1_0=0; 
   jsp v1_1=0; 
   jsp t1_v1_1=0; 
   t1_v1_0=t1_x;
   v1_0=x;
   v1_0=tanh(v1_0);
   t1_v1_1=(1-v1_0*v1_0)*t1_v1_0;
   v1_1=v1_0;
   t1_v_tanh=t1_v1_1;
   v_tanh=v1_1;
}
